exit

* load data --------------------------------------------------------------------

set more off

cap cd "your/directory/here"

use "master.dta", clear

* format data ------------------------------------------------------------------

collapse (first) state (mean) turnout, by(state_id elec_year)

drop if state_id == 6

xtset state_id elec_year

* Forecast turnout -------------------------------------------------------------

* prepare variables

by state_id: gen l_turnout = turnout[_n-1]
by state_id: gen l2_turnout = turnout[_n-2]

gen elec_year2 = elec_year ^ 2

gen error = .
gen error_abs = .
gen error_re_abs = .

* ------------------------------------------------------------------------------
* Prediction for 2017
* ------------------------------------------------------------------------------

xtmixed turnout l_turnout elec_year i.state_id || state_id: elec_year

predict turnout_pred

list state_id elec_year turnout_pred

keep state_id state elec_year turnout l_turnout turnout_pred

saveold "turnout_data.dta", replace

keep state_id elec_year turnout_pred

saveold "turnout.dta", replace
