exit

* load data --------------------------------------------------------------------

set more off

cap cd "your/directory/here"

use "master.dta", clear

* ------------------------------------------------------------------------------
* Out-of-sample forecasts
* ------------------------------------------------------------------------------

* ------------------------------------------------------------------------------
* For out-of-sample forecasts run from here to... ------------------------------

* This estimates models over sample before the years 1998, 2002, 2005, 2009, 2013
* and 2017 and then predict vote shares for the respective years

set more off
foreach year in 1998 2002 2005 2009 2013 2017 {
	di `year'
	
	* final
	* unweighted
	quietly: mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: voteshare_state || party:  if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	predict prtmp, fitted
	replace voteshare_hat = prtmp if elec_year == `year' & state != "Bundesgebiet"
	drop prtmp
	* weighted
	mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt]  || state: voteshare_state || party: if state != "Bundesgebiet", mle covariance(unstructured)
	predict prtmp, fitted
	replace voteshare_hat_w = prtmp if elec_year == `year' & state != "Bundesgebiet"
	drop prtmp
	* winner (2)
	* quietly: mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* winner (3)
	* mixed voteshare voteshare_l voteshare_state election_date_diff vshare_stateXelection_date_diff pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: voteshare_state voteshare_state election_date_diff || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* mixed voteshare voteshare_l voteshare_state election_date_diff vshare_stateXelection_date_diff pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: election_date_diff || party: voteshare_state if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* mixed voteshare voteshare_l voteshare_state election_date_diff vshare_stateXelection_date_diff pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: voteshare_state election_date_diff vshare_stateXelection_date_diff || _all: R.party if elec_year < `year' & state != "Bundesgebiet", mle covariance(identity)
	* empty model
	* xtmixed voteshare [] || state: || party: if elec_year < `year' & state != "Bundesgebiet"
	
	*** top four (incl. Three interactions; fewer vars w rand slopes.; more avg slopes) ***
	
	* hierarchical
	* xtmixed voteshare pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || state: voteshare_state  vshare_stateXelection_date_diff election_date_diff || party: if elec_year !=`year' & state != "Bundesgebiet"
	* cross-classified
	* xtmixed voteshare pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || state: voteshare_state  vshare_stateXelection_date_diff election_date_diff || _all: R.party if elec_year !=`year' & state != "Bundesgebiet"
	
	* (1) two interactions, lagged gpya, LDV, no weights, only 1 rand coeff var
	* quietly: mixed voteshare voteshare_l pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* (2) two interactions, lagged gpya, LDV, time WEIGHTS
	* quietly: mixed voteshare voteshare_l pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* quietly: mixed voteshare voteshare_l pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=w`year'] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	*UNEM:
	* (3) two interactions, unem, LDV, no time WEIGHTS
	* quietly: mixed voteshare voteshare_l pm_party unem pm_partyXunem pmyears pmyearsXpm_party || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* (4) two interactions, unem, LDV, time WEIGHTS
	* quietly: mixed voteshare voteshare_l pm_party unem pm_partyXunem pmyears pmyearsXpm_party [pw=timewt] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* quietly: mixed voteshare voteshare_l pm_party unem pm_partyXunem pmyears pmyearsXpm_party [pw=w`year'] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* weighted model
	* xtmixed voteshare || elec_year: if elec_year < `year' & state != "Bundesgebiet" , pweight(w`year')
	
	* xtmixed voteshare voteshare_state || state: || party: if elec_year < `year' & state != "Bundesgebiet"
	* xtmixed voteshare || party: voteshare_state pm_party || state: election_date_diff gpsa_l if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare voteshare_state pm_party election_date_diff gpsa_l || party:  || state: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare voteshare_state pm_party election_date_diff gpsa_l || party:voteshare_state  || state:gpsa_l if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare || party: voteshare_state pm_party gpsa_l pm_partyXgpsa_l || state: election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare || party: voteshare_state pm_party  pm_partyXgpsa_l || state: gpsa_l election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare voteshare_state vshare_stateXelection_date_diff pm_party gpsa_l pm_partyXgpsa_l election_date_diff || party: voteshare_state vshare_stateXelection_date_diff pm_party gpsa_l pm_partyXgpsa_l || state: election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare || party: voteshare_l voteshare_state vshare_stateXelection_date_diff pm_party gpsa_l pm_partyXgpsa_l || state: election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	*********** SIMPLE OLS MODELS **********
	* reg voteshare voteshare_state vshare_stateXelection_date_diff election_date_diff pm_party gpsa_l pm_partyXgpsa_l if elec_year < `year' & state != "Bundesgebiet"
	* reg voteshare voteshare_state vshare_stateXelection_date_diff election_date_diff pm_party gpsa_l pm_partyXgpsa_l i.party_id if elec_year < `year' & state != "Bundesgebiet"
	* reg voteshare voteshare_l voteshare_state vshare_stateXelection_date_diff election_date_diff pm_party gpsa_l pm_partyXgpsa_l if elec_year < `year' & state != "Bundesgebiet"
	* reg voteshare voteshare_l voteshare_state vshare_stateXelection_date_diff election_date_diff pm_party gpsa_l pm_partyXgpsa_l i.party_id if elec_year < `year' & state != "Bundesgebiet"
	
	**************** GPYA *********************
	* xtmixed voteshare || party: voteshare_l voteshare_state vshare_stateXelection_date_diff pm_party gpya_l pm_partyXgpya_l || state: election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* xtmixed voteshare || party: voteshare_state vshare_stateXelection_date_diff pm_party gpya_l pm_partyXgpya_l || state: election_date_diff if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	
	*************** unem & pmyears, only pre-data*********
	

	
	* econ interaction, LDV
	* xtmixed voteshare || state: voteshare_l voteshare_state pm_party gpya pm_partyXgpya || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	*quietly: xtmixed voteshare || state: voteshare_l voteshare_state vshare_stateXelection_date_diff pm_party gpya pm_partyXgpya || party: election_date_diff if elec_year != `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* pmyears, gpya inter, LDV
	* quietly: xtmixed voteshare || state: voteshare_l voteshare_state pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || party: if elec_year != `year' & state != "Bundesgebiet", mle covariance(unstructured)
	* pmyears, gpya inter, no LDV (better), rand intercepts for parties 
	*quietly: xtmixed voteshare || state: voteshare_state pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || party: if elec_year !=`year' & state != "Bundesgebiet"
	
	* unem inter
	*quietly: xtmixed voteshare || state: voteshare_state pm_party pmyears pmyearsXpm_party unem pm_partyXunem || party: if elec_year !=`year' & state != "Bundesgebiet"

	* all 3 interactions; gpya
	*quietly: xtmixed voteshare || state: voteshare_state pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya vshare_stateXelection_date_diff election_date_diff || party: if elec_year !=`year' & state != "Bundesgebiet"
	* fewer random slopes:	
*	quietly: xtmixed voteshare pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || state: voteshare_state  vshare_stateXelection_date_diff election_date_diff || party: if elec_year !=`year' & state != "Bundesgebiet"
	* yes! getting r.coeff se on this:
*	quietly: xtmixed voteshare pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya || party: || state: voteshare_state  vshare_stateXelection_date_diff election_date_diff if elec_year !=`year' & state != "Bundesgebiet"

	* drop one level! state is actually (=96) already picking up state-parties, it seems.
	*quietly: mixed voteshare pm_party pmyears pmyearsXpm_party gpya pm_partyXgpya ||state: voteshare_state  vshare_stateXelection_date_diff election_date_diff if elec_year !=`year' & state != "Bundesgebiet"

	
	
	
	*** gpya interaction only & LDV & time weight
		*xtmixed voteshare || state: voteshare_l voteshare_state pm_party gpya pm_partyXgpya [pw=timewt]|| party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	
	* same but lagged gpya
		*xtmixed voteshare || state: voteshare_l voteshare_state pm_party gpya_l pm_partyXgpya_l || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* One interaction; no LDV
		*xtmixed voteshare || state: voteshare_state pm_party gpya_l pm_partyXgpya_l || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	
	* gpya_l inter, pmyears inter, ldv
	*quietly: mixed voteshare || state: voteshare_l voteshare_state pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* with weights:
	*quietly: mixed voteshare || state: voteshare_l voteshare_state pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt]|| party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	
	***********************************************
	* same but: fewer rand coeff., more avg coeff:
	*quietly: mixed voteshare voteshare_l pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	* weights added: 
	* WINNER:
	*quietly: mixed voteshare voteshare_l pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)
	
	* unem, no weights
	*quietly: mixed voteshare voteshare_l pm_party unem pm_partyXunem pmyears pmyearsXpm_party || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	* unem, with weights
	* quietly: mixed voteshare voteshare_l pm_party unem pm_partyXunem pmyears pmyearsXpm_party [pw=timewt] || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	* unemd, no weights
	* quietly: mixed voteshare voteshare_l pm_party unemd pm_partyXunemd pmyears pmyearsXpm_party || state: voteshare_state  || party: if elec_year < `year' & state != "Bundesgebiet", mle covariance(unstructured)

	
	*predict prtmp, fitted
	*replace voteshare_hat = prtmp if elec_year == `year' & state != "Bundesgebiet"
	*drop prtmp
}


* Aggregation to national result ------------------------------------------------

* for 2017 turnout needs to be forecasted as well
* this is reason turnout.do provides a forecast which has been merged into master

* calculate the number of valid votes for 2017
replace valid = turnout_pred * electorate if elec_year == 2017

* list state party elec_year turnout_pred valid electorate if elec_year >= 2013

* calculate the number of votes received by a party
replace votes_hat = voteshare_hat/100 * valid if state != "Bundesgebiet"
replace votes_hat_w = voteshare_hat_w/100 * valid if state != "Bundesgebiet"  // weighted model

* sum the votes received by a party by election (therefore summing over
* state results of parties)
cap drop votes_hat_party votes_hat_party_w
bysort elec_year party: egen votes_hat_party = total(votes_hat) 
replace  votes_hat_party = . if state != "Bundesgebiet"
bysort elec_year party: egen votes_hat_party_w = total(votes_hat_w)  // weighted model
replace  votes_hat_party_w = . if state != "Bundesgebiet"  // weighted model

* calculate the total number of valid votes nationwide 
cap drop votes_hat_national votes_hat_national_w
by elec_year: egen votes_hat_national = total(votes_hat_party)
replace votes_hat_national = . if elec_year < 1998 | state != "Bundesgebiet"
by elec_year: egen votes_hat_national_w = total(votes_hat_party_w)  // weighted model
replace votes_hat_national_w = . if elec_year < 1998 | state != "Bundesgebiet"  // weighted model

* Estimate vote share at national level
replace voteshare_hat = votes_hat_party / votes_hat_national * 100 if state == "Bundesgebiet"
replace voteshare_hat_w = votes_hat_party_w / votes_hat_national_w * 100 if state == "Bundesgebiet"

* list state party elec_year voteshare voteshare_hat if elec_year >= 2013




* Calculate errors -------------------------------------------------------------

replace error = voteshare_hat - voteshare // error up until 2013 (no voteshares for 2017)
replace error_w = voteshare_hat_w - voteshare // error up until 2013 (no voteshares for 2017) (weighted model)
replace error_abs = abs(error)
replace error_abs_w = abs(error_w)  // (weighted model)
replace error2 = error^2
replace error2_w = error_w^2  // (weighted model)
replace error_abs_bigp = error_abs if party == "cdu_csu" | party == "spd"
replace error2_bigp = error2 if party == "cdu_csu" | party == "spd"

replace error_abs_wnelec = error_abs * wnelec
replace error2_wnelec = error2 * wnelec
replace error_abs_w2 = error_abs * w2
replace error2_w2 = error2 * w2

replace error2017 = voteshare_hat - poll if elec_year == 2017 & state == "Bundesgebiet"
replace error2017_abs = abs(error2017)
replace error2017_w = voteshare_hat_w - poll if elec_year == 2017 & state == "Bundesgebiet"
replace error2017_abs_w = abs(error2017_w)
replace error2017_2 = error2017^2


* ... here ---------------------------------------------------------------------
* ------------------------------------------------------------------------------

* 2017 forecast

list party voteshare_hat voteshare_hat_w if elec_year == 2017 & state == "Bundesgebiet"


* regression table -------------------------------------------------------------

* Table 1 in the article

* final
* unweighted
mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party  || state: voteshare_state || party: if state != "Bundesgebiet", mle covariance(unstructured) stddeviations
estimates store m1
* weighted
mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt]  || state: voteshare_state || party: if state != "Bundesgebiet", mle covariance(unstructured)
estimates store m2

esttab m1 m2 using "t_models.tex" ///
	, mtitles(Unweighted Weighted) se booktabs wide replace ///
	coeflabels(voteshare_l "Stimmanteil$_t{t-1}$" voteshare_state "Stimmanteil in Landtagswahl" ///
	pm_party "Kanzlerpartei" gpya_l "BIP Wachstum" ///
	pm_partyXgpya_l "Kanzlerpartei$\times$ BIP Wachstum" ///s
	pmyears "Jahre in der Regierung" pmyearsXpm_party "Kanzlerpartei $\times$ Jahre in der Regierung") ///
	transform(ln*: exp(@) exp(@))

* prepare reduced dataset of 2017 predictions (weighted model) -----------------

preserve
mixed voteshare voteshare_l voteshare_state  pm_party gpya_l pm_partyXgpya_l pmyears pmyearsXpm_party [pw=timewt]  || state: voteshare_state || party: if state != "Bundesgebiet", mle covariance(unstructured)
cap drop voteshare_hat 
cap drop voteshare_se
predict voteshare_hat, fitted
predict voteshare_se, stdp
keep state party elec_year voteshare_hat voteshare_se 
keep if elec_year == 2017 & state != "Bundesgebiet"
saveold "master_reduced.dta", replace
restore

* prepare table of forecasts ---------------------------------------------------

* Table 2 in the article, further processing in .R

preserve
keep if elec_year == 2017 & state == "Bundesgebiet"
keep party_id party voteshare_hat voteshare_hat_w poll poll_preschulz
order party voteshare_hat voteshare_hat_w poll poll_preschulz 
sort party_id
drop party_id
export delimited using "predictions.csv", replace
restore

* prepare table of forecasting errors (Bundesgebiet) ---------------------------

* part of Table 3 in the article, further processing in .R

preserve
keep if state == "Bundesgebiet"
keep party_id party elec_year error_abs error2 error_abs_w error2_w ///
	error_abs_naive1 error2_naive1 error_abs_naive2 error2_naive2
export delimited using "errors_bundesgebiet.csv", nolab replace
restore

* prepare table of forecasting errors (states) ---------------------------------

* part of Table 3 in the article, further processing in .R

preserve
keep if state != "Bundesgebiet"
keep state party_id party elec_year error_abs error2 error_abs_w error2_w ///
	error_abs_naive1 error2_naive1 error_abs_naive2 error2_naive2
export delimited using "errors_states.csv", nolab replace
restore
